package com.alipay.util;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.apache.commons.httpclient.NameValuePair;

import com.alipay.config.AlipayConfig;
import com.alipay.util.httpClient.HttpProtocolHandler;
import com.alipay.util.httpClient.HttpRequest;
import com.alipay.util.httpClient.HttpResponse;
import com.alipay.util.httpClient.HttpResultType;

/* *
 *AlipaySubmit
 *ܣ֧ӿύ
 *ϸ֧ӿڱHTMLıȡԶHTTP
 *汾3.2
 *ڣ2011-03-17
 *˵
 *´ֻΪ˷̻Զṩ룬̻ԸԼվҪռĵд,һҪʹøô롣
 *ôѧϰо֧ӿʹãֻṩһο
 */

public class AlipaySubmit {

    /**
     * Ҫ֧Ĳ
     * @param sParaTemp ǰĲ
     * @return ҪĲ
     */
    private static Map<String, String> buildRequestPara(Map<String, String> sParaTemp) {
        //ȥеĿֵǩ
        Map<String, String> sPara = AlipayCore.paraFilter(sParaTemp);
        //ǩ
        String mysign = AlipayCore.buildMysign(sPara);

        //ǩǩʽύ
        sPara.put("sign", mysign);
        sPara.put("sign_type", AlipayConfig.sign_type);

        return sPara;
    }

    /**
     * ύHTML
     * @param sParaTemp 
     * @param gateway صַ
     * @param strMethod ύʽֵѡpostget
     * @param strButtonName ȷϰťʾ
     * @return ύHTMLı
     */
    public static String buildForm(Map<String, String> sParaTemp, String gateway, String strMethod,
                                   String strButtonName) {
        //
        Map<String, String> sPara = buildRequestPara(sParaTemp);
        List<String> keys = new ArrayList<String>(sPara.keySet());

        StringBuffer sbHtml = new StringBuffer();

        sbHtml.append("<form id=\"alipaysubmit\" name=\"alipaysubmit\" action=\"" + gateway
                      + "_input_charset=" + AlipayConfig.input_charset + "\" method=\"" + strMethod
                      + "\">");

        for (int i = 0; i < keys.size(); i++) {
            String name = (String) keys.get(i);
            String value = (String) sPara.get(name);

            sbHtml.append("<input type=\"hidden\" name=\"" + name + "\" value=\"" + value + "\"/>");
        }

        //submitťؼ벻Ҫname
        sbHtml.append("<input type=\"submit\" value=\"" + strButtonName + "\" style=\"display:none;\"></form>");
        sbHtml.append("<script>document.forms['alipaysubmit'].submit();</script>");

        return sbHtml.toString();
    }

    /**
     * MAPתNameValuePair
     * @param properties  MAP
     * @return NameValuePair
     */
    private static NameValuePair[] generatNameValuePair(Map<String, String> properties) {
        NameValuePair[] nameValuePair = new NameValuePair[properties.size()];
        int i = 0;
        for (Map.Entry<String, String> entry : properties.entrySet()) {
            nameValuePair[i++] = new NameValuePair(entry.getKey(), entry.getValue());
        }

        return nameValuePair;
    }

    /**
     * ģԶHTTPPOST󣬻ȡ֧ķXML
     * @param sParaTemp 
     * @param gateway صַ
     * @return ֧XML
     * @throws Exception
     */
    public static String sendPostInfo(Map<String, String> sParaTemp, String gateway)
                                                                                    throws Exception {
        //
        Map<String, String> sPara = buildRequestPara(sParaTemp);

        HttpProtocolHandler httpProtocolHandler = HttpProtocolHandler.getInstance();

        HttpRequest request = new HttpRequest(HttpResultType.BYTES);
        //ñ뼯
        request.setCharset(AlipayConfig.input_charset);

        request.setParameters(generatNameValuePair(sPara));
        request.setUrl(gateway+"_input_charset="+AlipayConfig.input_charset);

        HttpResponse response = httpProtocolHandler.execute(request);
        if (response == null) {
            return null;
        }
        
        String strResult = response.getStringResult();

        return strResult;
    }
}
